#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//#define SLOW_INPUT
//#define SLOW_OUTPUT
//#define FULL_MEMSET

#define MAX_WIDTH 1000
#define MAX_HEIGHT 1000

struct wierzch
{
  char typ;
  char kier;
  int odl;
  int row, col;
  wierzch *bfs_next;
} mapa[MAX_HEIGHT][MAX_WIDTH];

wierzch **bfs_last;

inline void spr_dodaj(wierzch *w, char kier, int odl)
{
  if (w->typ == 'X')
    return;

  if (w->odl > 0 && w->odl < odl)
    return;
  
  if (w->odl == odl && w->kier < kier)
    return;

  if (w->odl == 0)
  {
    w->odl = odl;
#ifndef FULL_MEMSET
    w->bfs_next = NULL;
#endif
    *bfs_last = w;
    bfs_last = &w->bfs_next;
  }
  w->kier = kier;
}

void wypisz_droge(wierzch *w)
{
  while (w->typ != '*')
  {
#ifdef SLOW_OUTPUT
    printf("%c", w->kier);
#else
    putchar(w->kier);
#endif

    switch (w->kier)
    {
      case 'G':
        w = &mapa[w->row-1][w->col];
        break;
      case 'D':
        w = &mapa[w->row+1][w->col];
        break;
      case 'P':
        w = &mapa[w->row][w->col+1];
        break;
      case 'L':
        w = &mapa[w->row][w->col-1];
        break;
      default:
        fprintf(stderr, "Nieznany kierunek %02x ('%c')\n", (int)w->kier,
	  w->kier);
	exit(1);
    }
  }
  putchar('\n');
}

int main(void)
{
  int ipr, npr;
  scanf("%d\n", &npr);
  for (ipr = 0; ipr < npr; ipr++)
  {
    int h, w;
    int i, j;
    bool jestStart = false;
    wierzch *curr_wierzch = NULL;
    
#ifdef FULL_MEMSET
    memset(mapa, 0, sizeof(mapa));
#endif
    scanf("%d %d\n", &h, &w);
    for (i = 0; i < h; i++)
    {
      for (j = 0; j < w; j++)
      {
        char c;
#ifdef SLOW_INPUT
        scanf("%c", &c);
#else
        c = getchar();
#endif
        if (c!='.' && c!='S' && c!='*' && c!='X')
	{
	  fprintf(stderr, "Blad wejscia - wczytalem znak  %02x ('%c')\n", (int)c, c);
	  return 1;
	}
	
	if (c=='*')
          curr_wierzch = &mapa[i][j];
	if (c=='S')
	  jestStart = true;

        mapa[i][j].row = i;
	mapa[i][j].col = j;
        mapa[i][j].typ = c;
#ifndef FULL_MEMSET
        mapa[i][j].odl = 0;
#endif
      }
      getchar();       /* newline */
    }
    
    if (curr_wierzch == NULL)
    {
      fprintf(stderr, "Blad wejscia - nie znaleziono '*'\n");
      return 1;
    }
    
    if (!jestStart)
    {
      fprintf(stderr, "Blad wejscia - nie znaleziono 'S'\n");
      return 1;
    }
    
    curr_wierzch->odl = 1;
#ifndef FULL_MEMSET
    curr_wierzch->bfs_next = NULL;
#endif
    bfs_last = &curr_wierzch->bfs_next; 
    while (curr_wierzch)
    {
      int curr_row = curr_wierzch->row;
      int curr_col = curr_wierzch->col;
      int odl = curr_wierzch->odl;
      
      if (curr_wierzch->typ == 'S')
      {
        wypisz_droge(curr_wierzch);
	break;
      }
      if (curr_row < h-1)
        spr_dodaj(&mapa[curr_row+1][curr_col], 'G', odl+1);
      if (curr_row > 0)
        spr_dodaj(&mapa[curr_row-1][curr_col], 'D', odl+1);
      if (curr_col < w-1)
        spr_dodaj(&mapa[curr_row][curr_col+1], 'L', odl+1);
      if (curr_col > 0)
        spr_dodaj(&mapa[curr_row][curr_col-1], 'P', odl+1);

      curr_wierzch = curr_wierzch->bfs_next;
    }
    
    
    if (curr_wierzch == NULL)
      printf("BRAK\n");

/*    for (i = 0; i < h; i++)
    {
      for (j = 0; j < w; j++)
        printf("%02d%c ", mapa[i][j].odl, (mapa[i][j].kier!=0?mapa[i][j].kier:'-'));
      printf("\n");
    }
    printf("\n");*/
  }
  return 0;
}
