program skarb;

const
    MAX_WIDTH  = 1000;
    MAX_HEIGHT = 1000;

type
    Queue = record
      tab: array[0..(2*MAX_HEIGHT*MAX_WIDTH)-1] of longint;
      head: longint;
      tail: longint;
    end;

var
    plan: array[0..MAX_HEIGHT-1] of array[0..MAX_WIDTH-1] of char;
    when: array[0..MAX_HEIGHT-1,0..MAX_WIDTH-1] of longint;
    from: array[0..MAX_HEIGHT,0..MAX_WIDTH] of longint;
    output: array[0..MAX_HEIGHT*MAX_WIDTH] of char;
    output_pos: LongInt;
    num_zestawow: longint;
    zest: longint;
    width: longint;
    height: longint;
    temp: array[0..MAX_WIDTH-1] of char;
    j, k: longint;
    startx, starty: longint;
    endx, endy: longint;
    qq: Queue;
    curx, cury: longint;
    found: boolean;
    result: longint;

procedure init_queue(var q:Queue);
begin
  q.head := 0;
  q.tail := 0;
end;

procedure enqueue(var q:Queue; val:longint);
begin
  q.tab[q.tail] := val;
  inc(q.tail);
end;

function dequeue(var q:Queue):longint;
begin
  dequeue := q.tab[q.head];
  inc(q.head);
end;

procedure push(var q:Queue; val:longint);
begin
  q.tab[q.tail] := val;
  inc(q.tail);
end;

function pop(var q:Queue): longint;
begin
  dec(q.tail);
  pop := q.tab[q.tail];
end;

function empty(var q:Queue):boolean;
begin
  if q.head = q.tail then
    empty := true
  else
    empty := false;
end;

procedure try_(x:longint; y:longint; wh:longint; fr:longint);
begin
  if (x >= 0) and (x < width) and (y >= 0) and (y < height) then begin
    if (plan[y][x] <> 'X') and (when[y,x] = -1) then begin
      when[y,x] := wh;
      from[y,x] := fr;
      enqueue(qq, x);
      enqueue(qq, y);

      if plan[y][x] = '*' then begin
        found := true;
        result := wh;
        endx := x;
        endy := y;
      end;
    end;
  end;
end;

begin
  readln (num_zestawow);

  for zest := 1 to num_zestawow do begin
    readln (height, width);

    for j := 0 to height - 1 do begin
      readln (plan[j]);
      
      for k := 0 to width - 1 do begin
        when[j,k] := -1;

        if plan[j][k] = 'S' then begin
          startx := k;
          starty := j;
        end;
      end;
    end;

    init_queue(qq);
    enqueue(qq, startx);
    enqueue(qq, starty);
    when[starty, startx] := 0;

    found := false;

    while not found and not empty(qq) do begin
      curx := dequeue(qq);
      cury := dequeue(qq);

      try_(curx, cury + 1, when[cury,curx] + 1, 0); { D }
      try_(curx, cury - 1, when[cury,curx] + 1, 1); { G }
      try_(curx - 1, cury, when[cury,curx] + 1, 2); { L }
      try_(curx + 1, cury, when[cury,curx] + 1, 3); { P }
    end;

    if not found then
      writeln('BRAK')
    else begin
      curx := endx;
      cury := endy;

      init_queue(qq);

      while (curx <> startx) or (cury <> starty) do begin
        push(qq, from[cury, curx]);

        case from[cury, curx] of
          0: dec(cury);
          1: inc(cury);
          2: inc(curx);
          3: dec(curx);
        end;
      end;

      { writeln(result); }

      
      output_pos:=0;
      while not empty(qq) do begin
        case pop(qq) of
          0: output[output_pos]:='D';
          1: output[output_pos]:='G';
          2: output[output_pos]:='L';
          3: output[output_pos]:='P';
        end;
	Inc(output_pos);
      end;
      output[output_pos]:=#0;
      WriteLn(output);
    end;
  end;
end.
